﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.ScheduleView;

namespace CustomSpecialSlots
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			InitializeComponent();

			List<Slot> specialSlots = new List<Slot>();
			specialSlots.Add(new SundayOccurence()
				{ 
					Start = new DateTime(2011, 1, 1),
					End = new DateTime(2011, 1, 1, 23, 59, 59),
					RecurrencePattern = new RecurrencePattern(null, RecurrenceDays.Sunday, RecurrenceFrequency.Weekly, 1, null, null)
				});
			specialSlots.Add(new SaturdayOccurence()
			{
				Start = new DateTime(2011, 1, 1),
				End = new DateTime(2011, 1, 1, 23, 59, 59),
				RecurrencePattern = new RecurrencePattern(null, RecurrenceDays.Saturday, RecurrenceFrequency.Weekly, 1, null, null)
			});
			specialSlots.Add(new WorkingHourOccurence()
			{
				Start = new DateTime(2011, 1, 1, 9, 0, 0),
				End = new DateTime(2011, 1, 1, 18, 0, 0),
				RecurrencePattern = new RecurrencePattern(null, RecurrenceDays.Monday | RecurrenceDays.Tuesday | RecurrenceDays.Wednesday | RecurrenceDays.Thursday | RecurrenceDays.Friday, RecurrenceFrequency.Weekly, 1, null, null)
			});
			this.SpecialSlotSchedule.SpecialSlotsSource = specialSlots;
		}
	}

	public class SundayOccurence : Slot
	{
		public override Slot Copy()
		{
			return new SundayOccurence()
			{
				Start = this.Start,
				End = this.End,
				RecurrencePattern = this.RecurrencePattern.Copy()
			};
		}
	}
	public class SaturdayOccurence : Slot
	{
		public override Slot Copy()
		{
			return new SaturdayOccurence()
			{
				Start = this.Start,
				End = this.End,
				RecurrencePattern = this.RecurrencePattern.Copy()
			};
		}
	}
	public class WorkingHourOccurence : Slot
	{
		public override Slot Copy()
		{
			return new WorkingHourOccurence()
			{
				Start = this.Start,
				End = this.End,
				RecurrencePattern = this.RecurrencePattern.Copy()
			};
		}
	}

	public class SpecialSlotStyleSelector : ScheduleViewStyleSelector
	{
		public Style SundayStyle { get; set; }
		public Style SaturdayStyle { get; set; }
		public Style WorkingHourStyle { get; set; }

		public override Style SelectStyle(object item, DependencyObject container, ViewDefinitionBase activeViewDeifinition)
		{
			if (item is SundayOccurence)
			{
				return this.SundayStyle;
			}
			else if (item is SaturdayOccurence)
			{
				return this.SaturdayStyle;
			}
			else if (item is WorkingHourOccurence)
			{
				return this.WorkingHourStyle;
			}
			return base.SelectStyle(item, container, activeViewDeifinition);
		}
	}
}
